﻿@model AEWeb.ViewModels.KPI.KpiViewModel
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = "Add KPI to dashboard";
    Layout = "_DashboardLayout";
}
@section Styles {
    <style>
        /* HIDE RADIO */
        .imageSelector [type=radio] {
            position: absolute;
            opacity: 0;
            width: 0;
            height: 0;
        }

            /* IMAGE STYLES */
            .imageSelector [type=radio] + img {
                cursor: pointer;
            }

            /* CHECKED STYLES */
            .imageSelector [type=radio]:checked + img {
                outline: 2px solid #01cdd4;
            }
    </style>
}
<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>@Localizer["PageTitle"]</h2>
        <small>@Localizer["PageDescription"]</small>
    </div>
    <div class="col-lg-2">

    </div>
</div>

<div class="wrapper wrapper-content">

    <div class="row">
        <div class="col-lg-6">
            <div class="ibox">
                <div class="ibox-title">
                    <a asp-action="Index" asp-route-rowid="@Model.DashboardRowId">@Localizer["BackToList"]</a>
                </div>

                <div class="ibox-content">
                    <div class="container-fluid">
                        <div class="row">
                            @{
                                var actionForThisForm = "Insert";
                            }
                            @if (Model.KpiId != null)
                            {
                                actionForThisForm = "Update";
                            }
                            <form asp-action="@actionForThisForm" method="post" class="col-md-10">
                                <div class="form-group">
                                    @(Html.Kendo().ComboBox()
                                      .Name("groups")
                                      .Placeholder("Type letters in group name or description")
                                      .DataTextField("name")
                                      .DataValueField("groupid")
                                      .HtmlAttributes(new { style = "width:100%;" })
                                      .Template("#= name #")
                                      .Filter(FilterType.Contains)
                                      .AutoBind(false)
                                      .Value(Model.GroupId)
                                      .Text(Model.GroupId)
                                      .MinLength(3)
                                      .DataSource(source =>
                                      {
                                          source.Read(read =>
                                          {
                                              read.Action("GetKpiGroupBySearchJSON", "DashboardKpi");
                                          })
                                          .ServerFiltering(true);
                                      })
                                    )
                                </div>
                                <div class="form-group">
                                    @(Html.Kendo().ComboBox()
                                        .Name("kpiclasses")
                                      .Placeholder("Type letters for flavor")
                                      .DataTextField("flavor")
                                      .DataValueField("classname")
                                      .HtmlAttributes(new { style = "width:100%;" })
                                      .Template("#= flavor #")
                                      .Filter(FilterType.Contains)
                                      .AutoBind(false)
                                      .Value(Model.KpiId)
                                      .Text(Model.KpiFlavor)
                                      .MinLength(3)
                                      .DataSource(source =>
                                      {
                                          source.Read(read =>
                                          {
                                              read.Action("GetKpiBySearchJSON", "DashboardKpi")
                                                  .Data("filterFlavors");
                                          })
                                          .ServerFiltering(true);
                                      })
                                      .Enable(false)
                                      .AutoBind(false)
                                      .CascadeFrom("groups")
                                      .Events(e => e
                                            .Change("onKpiChange")
                                        )
                                    )
                                    <script>
                                        function filterFlavors() {
                                            return {
                                                groups: $("#groups").val(),
                                                productFilter: $("#kpiclasses").data("kendoComboBox").input.val()
                                            };
                                        }
                                        function onKpiChange() {
                                            var combo = $("#kpiclasses").data("kendoComboBox");
                                            $("#KpiMnemonic").val(combo.value());
                                        }
                                    </script>
                                    @Html.HiddenFor(m => m.KpiMnemonic)
                                </div>
                                @{
                                    var buttonText = "Add KPI";
                                }
                                @if (Model.KpiId != null)
                                {
                                    buttonText = "Update KPI";
                                    <div class="form-group imageSelector">
                                        @foreach (KPIClassLibrary.KPI.KPIChartType chartType in Model.SupportedChartTypes)
                                        {
                                            <label>
                                                @Html.RadioButtonFor(model => model.ChartType, chartType.ToString())
                                                <img src="@Href(Model.GetImageForChartType(chartType))" />
                                            </label>
                                        }
                                    </div>
                                    <div class="form-group">
                                        @Html.LabelFor(m => m.NumberOfPeriods)
                                        @Html.TextBoxFor(m => m.NumberOfPeriods, new { @class = "form-control" })
                                    </div>
                                    <div class="form-group">
                                        @Html.LabelFor(m => m.DivWidth)
                                        @Html.DropDownListFor(m => m.DivWidth, new SelectList(AEWeb.ViewModels.KPI.KpiViewModel.DivWidths, "Value", "Name"), new { @class = "form-control" })
                                    </div>
                                }
                                @Html.HiddenFor(m => m.DashboardRowId)
                                @Html.HiddenFor(m => m.DashboardId)
                                @Html.HiddenFor(m => m.DashboardKpiId)
                                @Html.HiddenFor(m => m.KpiMnemonic)
                                <div class="form-group">
                                    <button type="submit" class="btn btn-default btn-sm">@buttonText</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

@section Scripts {
    <script src="~/lib/kpi/sparkline.js"></script>
    <script src="~/lib/kpi/columnchart.js"></script>
    <script src="~/lib/kpi/piechart.js"></script>

    <script>
        Highcharts.setOptions({
            //colors: ['#2C82C9', '#61BD6D', '#ED561B', '#F7DA64', '##FBA026', '#EB6B56', '#A38F84', '#9365B8', '#3D8EB9','#41A85F','#FAC51C','#F37934','#D1D5D8','#475577']
            colors: ['#16A64F', '#B8E259', '#0B8695', '#60C7B9', '#E9832A', '#FEBB40', '#B73A8D']
        });

        $(document).ready(function () {

            // Add slimscroll to element
            $('.scroll_content').slimscroll({
                height: '400px'
            })


        });

    </script>
}